<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="tLang('product', '产品编码')" prop="code">
        <el-input v-model="queryParams.code" :placeholder="tLang('common', '请输入') + tLang('product', '产品编码')" clearable
          @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item :label="tLang('product', '针号')" prop="needleNum">
        <el-input v-model="queryParams.needleNum" :placeholder="tLang('common', '请输入') + tLang('product', '针号')" clearable
          @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item :label="tLang('product', '面线信息')" prop="surfacelineId">
        <el-input v-model="queryParams.surfacelineId" :placeholder="tLang('common', '请输入') + tLang('product', '面线信息')"
          clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item :label="tLang('product', '底线信息')" prop="bottomlineId">
        <el-input v-model="queryParams.bottomlineId" :placeholder="tLang('common', '请输入') + tLang('product', '底线信息')"
          clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item :label="tLang('product', '梭芯信息')" prop="shuttlecoreId">
        <el-input v-model="queryParams.shuttlecoreId" :placeholder="tLang('common', '请输入') + tLang('product', '梭芯信息')"
          clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="search" size="mini" @click="handleQuery">{{ tLang('common', '搜索') }}</el-button>
        <el-button icon="refresh" size="mini" @click="resetQuery">{{ tLang('common', '重置') }}</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="plus" size="mini" @click="handleAdd"
          v-hasPermi="['product:needle:add']">{{ tLang('common', '新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['product:needle:edit']">{{ tLang('common', '修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['product:needle:remove']">{{ tLang('common', '删除') }}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="download" size="mini" @click="handleExport"
          v-hasPermi="['product:product:export']">导出</el-button>
      </el-col> -->
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>
    <el-table v-loading="loading" :data="productionLineRelationList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" :label="tLang('common', '序号')" width="60" align="center" />
      <!-- <el-table-column :label="主键id" align="center" prop="id" /> -->
      <el-table-column :label="tLang('product', '产品编码')" align="center" v-if="columns[0].visible" prop="code" />
      <el-table-column :label="tLang('product', '针号')" align="center" v-if="columns[1].visible" prop="needleNum" />
      <el-table-column :label="tLang('product', '面线信息')" align="center" v-if="columns[2].visible" prop="surfacelineCode" />
      <el-table-column :label="tLang('product', '底线信息')" align="center" v-if="columns[3].visible"
        prop="bottomlineCode" />
      <el-table-column :label="tLang('product', '梭芯信息')" align="center" v-if="columns[4].visible" prop="shuttlecoreCode" />
      <!-- <el-table-column :label="tLang('product', '排序')" align="center" v-if="columns[5].visible" prop="sort" /> -->
      <el-table-column :label="tLang('product', '最小张力')" align="center" v-if="columns[6].visible" prop="min" />
      <el-table-column :label="tLang('product', '最大张力')" align="center" v-if="columns[7].visible" prop="max" />
      <!-- <el-table-column :label="tLang('product','类型')" align="center" v-if="columns[8].visible" prop="type" /> -->
      <!-- <el-table-column :label="备注" align="center" prop="remark" /> -->
      <el-table-column :label="tLang('common', '操作')" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-tooltip :content="tLang('common', '修改')" placement="top" v-if="scope.row.userId !== 1">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
              v-hasPermi="['product:needle:edit']"></el-button>
          </el-tooltip>
          <el-tooltip :content="tLang('common', '删除')" placement="top" v-if="scope.row.userId !== 1">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
              v-hasPermi="['product:needle:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <div class="pagination">
      <el-pagination :hide-on-single-page="true" v-model:current-page="queryParams.pageNum"
        v-model:page-size="queryParams.pageSize" :page-sizes="[25, 50, 100, 150]"
        layout="total, sizes, prev, pager, next, jumper" :total="total" @size-change="getList"
        @current-change="getList" />
    </div>
    <AddEdit :title="title" v-model="open" :form="form" @submitForm="submitForm"></AddEdit>
  </div>
</template>

<script setup>
import { ref, reactive, watch, onMounted } from 'vue'
import { listProductionLineRelation, getProductionLineRelation, delProductionLineRelation, addProductionLineRelation, updateProductionLineRelation } from '@/api/casm/product'
import AddEdit from './add_edit.vue';
const { proxy } = getCurrentInstance();

// 遮罩层
let loading = ref(true)
// 选中数组
let ids = ref([])
// 非单个禁用
let single = ref(true)
// 非多个禁用
let multiple = ref(true)
// 显示搜索条件
let showSearch = ref(false)
// 表单参数
let form = ref({})
// 是否显示弹出层
let open = ref(false)
// 弹出层标题
let title = ref("")
// 查询参数
let queryParams = reactive({
  pageNum: 1,
  pageSize: 10,
  code: null,
  needleNum: null,
  surfacelineId: null,
  bottomlineId: null,
  shuttlecoreId: null,
  sort: null,
  min: null,
  max: null,
  type: null,
})

let total = ref(0)
// 针(底线/面线)/张力表格数据
let productionLineRelationList = ref([])
// 列显隐信息
const columns = ref([
  { key: 0, label: proxy.tLang('product', '产品编码'), visible: true },
  { key: 1, label: proxy.tLang('product', '针号'), visible: true },
  { key: 2, label: proxy.tLang('product', '面线信息'), visible: true },
  { key: 3, label: proxy.tLang('product', '底线信息'), visible: true },
  { key: 4, label: proxy.tLang('product', '梭芯信息'), visible: true },
  { key: 5, label: proxy.tLang('product', '排序'), visible: true },
  { key: 6, label: proxy.tLang('product', '最小值'), visible: true },
  { key: 7, label: proxy.tLang('product', '最大值'), visible: true },
  // { key: 8, label: proxy.tLang('product','类型'), visible: true },
]);

let infoDialog = ref(false)
let productinfo = ref({})
/** 查询设备信息列表 */
function getList() {
  loading.value = true;
  listProductionLineRelation(queryParams).then(response => {
    productionLineRelationList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });

}
// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length !== 1
  multiple.value = !selection.length
}

//** 搜索按钮操作 */
function handleQuery() {
  queryParams.pageNum = 1;
  getList();
}
/** 重置按钮操作 */
function resetQuery() {
  queryParams.pageNum = 1
  queryParams.pageSize = 10
  queryParams.name = null
  queryParams.code = null

  handleQuery();
}
/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = proxy.tLang('common', '添加') + ' ' + proxy.tLang('product', '针号');
}

/**详情按钮操作 */
function handleInfo(row) {
  productinfo.value = row
  infoDialog.value = true
}

/** 提交按钮 */

/** 提交按钮 */
function submitForm(propform) {

  if (propform.id != null) {
    updateProductionLineRelation(propform).then(response => {
      proxy.$modal.msgSuccess(proxy.tLang('common', '修改成功'));
      open.value = false;
      getList();
    });
  } else {
    addProductionLineRelation(propform).then(response => {
      proxy.$modal.msgSuccess(proxy.tLang('common', '新增成功'));
      open.value = false;
      getList();
    });
  }
}


// 取消按钮
function cancel() {
  open.value = false;
  reset();
}
// 表单重置
function reset() {
  form.value = {
    id: null,
    code: null,
    needleNum: null,
    surfacelineCode: null,
    bottomlineCode: null,
    sort: null,
    min: 1,
    max: 1,
    type: null,
    createTime: null,
    remark: null
  };
  //resetForm("form");
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const id = row.id || ids.value

  getProductionLineRelation(id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = proxy.tLang('common', '修改') + ' ' + proxy.tLang('product', '针号');
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const id = row.id || ids.value;
  proxy.$modal.confirm(proxy.tLang('tip', '确定删除选中记录？') + ` [${id}]`).then(function () {
    return delProductionLineRelation(id);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess(proxy.tLang('common', '删除成功'));
  }).catch(() => { });
}
onMounted(() => {
  getList();
})
</script>

<style lang="scss" scoped>
.pagination {
  width: 100%;
  margin: 10px;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
